--Bapt-tech
--github.com/bapt-tech
--license Creative Commons CC-BY-SA
--Enjoy !


-- init.lua
minetest.register_privilege("openinv", {
    description = "Allows player to open other players' inventories.",
    give_to_singleplayer = false,
})

minetest.register_privilege("openec", {
    description = "Allows player to open other players' Ender Chests.",
    give_to_singleplayer = false,
})

-- Function to open player inventory
local function open_player_inventory(name, param)
    if not minetest.check_player_privs(name, {openinv = true}) then
        return false, "You don't have permission to use this command"
    end

    local player = minetest.get_player_by_name(param)
    if not player then
        return false, "Player not found"
    end

    local inv = player:get_inventory()
    local formspec = "size[8,9]" ..
                     "list[detached:"..param.."_inv;main;0,0;8,4;]" ..
                     "list[current_player;main;0,5;8,4;]"

    local detached_inv = minetest.create_detached_inventory(param.."_inv", {
        allow_move = function() return 0 end,
        allow_put = function() return 0 end,
        allow_take = function() return 0 end,
    })

    detached_inv:set_size("main", inv:get_size("main"))
    detached_inv:set_list("main", inv:get_list("main"))

    minetest.show_formspec(name, "openinvmod:player_inventory", formspec)
    return true
end

-- Function to open player Ender Chest
local function open_player_enderchest(name, param)
    if not minetest.check_player_privs(name, {openec = true}) then
        return false, "You don't have permission to use this command"
    end

    local player = minetest.get_player_by_name(param)
    if not player then
        return false, "Player not found"
    end

    local ec_inv = player:get_inventory():get_list("enderchest")
    if not ec_inv then
        return false, "Player does not have an Ender Chest inventory"
    end

    local formspec = "size[8,9]" ..
                     "list[detached:"..param.."_ec;main;0,0;8,3;]" ..
                     "list[current_player;main;0,5;8,4;]"

    local detached_ec = minetest.create_detached_inventory(param.."_ec", {
        allow_move = function() return 0 end,
        allow_put = function() return 0 end,
        allow_take = function() return 0 end,
    })

    detached_ec:set_size("main", #ec_inv)
    detached_ec:set_list("main", ec_inv)

    minetest.show_formspec(name, "openinvmod:enderchest", formspec)
    return true
end

minetest.register_chatcommand("openinv", {
    params = "<player>",
    description = "Open the inventory of another player.",
    privs = {openinv = true},
    func = open_player_inventory
})

minetest.register_chatcommand("openec", {
    params = "<player>",
    description = "Open the Ender Chest of another player.",
    privs = {openec = true},
    func = open_player_enderchest
})
